# Teaching Hub @ IMGW

<img src="Documentation/jupyterhub-logo.svg" width="300px">

- Address: [Teaching Hub](https://srvx1.img.univie.ac.at)
- Access to the Teaching Hub can be done only via a browser.
- Access to SRVX1 via a terminal (Putty,...)


[[_TOC_]]

## How to get access?
Usually **your teacher** is going to **sign you up** and you will recieve one or two emails containing information on how to login.
You will recieve access to the Teaching Hub usually for 6 month. Can be extended for good reasons or until a teacher signs you up again.

## You recieved two Emails
This means you are new to the SERVERS and the Teaching Hub.

The first email contains your login details for SRVX1, you get a username (Matrikelnumber) and a password. It looks like this:
```
Dear TeachingHub User Monkey
Some of your user information has been updated.
 
Server Account Specification:
servers: srvx1.img.univie.ac.at
username: monkey
password: ABCDEFGHIJK (Change as soon as possible on all servers)
uid: 40XXX
gid: 59000
Name: Monkey Banana
Email: a000000@unet.univie.ac.at
GECOS: Monkey Banana (a000000@unet.univie.ac.at)
home: /home/srvx11/lehre/users/a000000
shell: /bin/bash
Account expires: 2021-08-30
...
```
Use these to login to the server and change the password to something better and still something that is safe:
```bash
$ ssh [user]@srvx1.img.univie.ac.at
----------------------------------------------
                _                                  
              (`  ).                          
             (     ).                     
)           _( SRVX1 '`.                
        .=(`(      .   )     .--       
       ((    (..__.:'-'   .+(   )                   
`.     `(       ) )       (   .  )     
  )      ` __.:'   )     (   (   )) 
)  )  ( )       --'       `- __.'   
.-'  (_.'          .')              
                  (_  )                       
                              131.130.157.5          
--..,___.--,--'`,---..-.--+--.,,-,,.-..-._.-.-
----------------------------------------------
Teaching Server @IMGW 
Environmental Modules: module av
Jupyterhub: https://srvx1.img.univie.ac.at
Usage Profile: Students
----------------------------------------------

$ passwd 
Changing password for user [user].
Changing password for [user].
(current) UNIX password: 
```
After you completed these steps you are free to login anytime and use the server. 
The second email contains your Teaching Hub credentials. See below.

## You recieved one Email
the email you recieved contains credentials for the Teaching Hub. This email contains your username (the same as on SRVX1 for login), a new password (only for the Teaching Hub) and a secret (16 digit code). They look like this:
```
Dear TeachingHub User Monkey
Some of your user information has been updated.
 
TeachingHub Account Specification:
servers: https://srvx1.img.univie.ac.at
username: monkey
password: ABCDEFGHIJK (signed in, click on user name, upper right corner)
Email: a000000@univie.ac.at
Secret: 1A2B3C4D5E6F7G8H

Please note that the TeachingHub is open from the web. 
Two-factor Authentication is required. Download one of these apps and use your secret to generate TOTP (Time based One Time Passwords).
Authy (https://authy.com/download/)
FreeOTP (https://freeotp.github.io/)
Google Auth (https://play.google.com/store/apps/details?id=com.google.android.apps.authenticator2)
...
```
You need to download one of these apps:
- [2FA Authenticator](https://2fas.com) :rocket: (android, ios)
- [Authy](https://authy.com/download/) 
- [FreeOTP](https://freeotp.github.io/)
- [Google Auth](https://play.google.com/store/apps/details?id=com.google.android.apps.authenticator2)
- or any other (search `2fa apps` and you will find plenty)

I recommend using your phone and an app there, as this is the most secure way. And with you phone you can scan the qr code, which looks like this:

<img src="Documentation/teachinghub-qrcode.png" width="300px">

When you scan to your Authenticator App, it will automatically get the details (username, Secret) required to generate every 30 seconds a Time-based One Time  Password (TOTP). Like this:

![](Documentation/teachinghub-authenticator.png)

If you want to use a desktop or other app that might not scan QR codes, you can fill in the details manually like this:
- Provider: `TeachingHub`
- Account: `[user]` your username, here `monkey`
- Token or Secret or Hash: `1A2B3C4D5E6F7G8H` is the secret from your email.

![](Documentation/teachinghub-authenticator-manual.png)

The combination of username, password and TOTP needs to be used to sign in:

![](Documentation/teachinghublogin.png)

This sounds all really complicated, but I promise this will be easier from time to time. Don't forget that this for our all security and your contribution is appreciated! Thanks.

Now you are ready to go to the teaching hub and sign in:

[Teaching Hub](https://srvx1.img.univie.ac.at)


# Teaching Hub Notebooks and Kernels

Currently there are several Notebooks with different Kernels (Python kernels) installed at SRVX1. Look at the logos, if SRVX1 is in there then you will have access to these notebooks and kernels. If SRVX2 or SRVX8 are in the logo you might not have access as this is for researchers.

![](Documentation/teachinghubnotebooks.png)

As you can see it is also possible to launch a terminal inside the TeachingHub and you will find you files from your home directory there. 

It might be that your course has a separate Notebook/Kernel for you, with installed packages and dependencies required for this specific course. However, these Notebooks/Kernels are only available during these lectures and  might be removed in the future. So be aware of that. Note that you can easily change a kernel in your notebook. So no need to delete, copy or do anything. Your data/notebook information is safe.

![](Documentation/teachinghubnotebooks_kernels.png)






